/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 8740_SUPTRGO.sql

Descrio:
Grava log de excluso de cotao.

Criao:
24/12/2003 Adriano de Arajo
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'GRAVA_LOGCOLETAPR'  and
            type = 'TR'                 and
            u.uid = o.uid               and
            u.name = USER)
  DROP TRIGGER GRAVA_LOGCOLETAPR
  GO

CREATE TRIGGER GRAVA_LOGCOLETAPR
ON COLETAPR
FOR DELETE, UPDATE

AS

DECLARE @V_DSREMOTEADDR   VARCHAR(50);
DECLARE @V_DSREMOTEHOST   VARCHAR(50);
DECLARE @V_DSSERVERRDM    VARCHAR(50);
DECLARE @V_DSMETUSULOG    VARCHAR(50);
DECLARE @V_DSSERVMETHOD   VARCHAR(30);
DECLARE @V_CDOPECOLLOG    VARCHAR(12);
DECLARE @V_IDGRAVLOGCOT   VARCHAR(03);

DECLARE @V_COUNT INT;

/* Variveis do cursor */
DECLARE @V_IDCOMANDO      VARCHAR(1);
DECLARE @V_CDFILIAL       VARCHAR(4);
DECLARE @V_NRCOLEPRECO    VARCHAR(10);
DECLARE @V_CDOPERADOR     VARCHAR(12);
DECLARE @V_DTCOLEPREC     DATETIME;
DECLARE @V_NRSEMAINIC     VARCHAR(2);
DECLARE @V_NRSEMAFINAL    VARCHAR(2);
DECLARE @V_DTINIVALCOL    DATETIME;
DECLARE @V_DTFINVALCOL    DATETIME;
DECLARE @V_NRCOLEORIGCO   VARCHAR(10);
DECLARE @V_DTINCLCOLET    DATETIME;
DECLARE @V_CDOPERINCL     VARCHAR(12);
DECLARE @V_IDDISMONTLIS   VARCHAR(1);

BEGIN
  DECLARE C_DADOS CURSOR FOR
   SELECT
     'D' AS IDCOMANDO,
     CDFILIAL,
     NRCOLEPRECO,
     CDOPERADOR,
     DTCOLEPREC,
     NRSEMAINIC,
     NRSEMAFINAL,
     DTINIVALCOL,
     DTFINVALCOL,
     NRCOLEORIGCO,
     DTINCLCOLET,
     CDOPERINCL,
     IDDISMONTLIS
   FROM
     DELETED
   WHERE
     0 = (SELECT COUNT(*) FROM INSERTED)

   UNION ALL

   SELECT
     'U' AS IDCOMANDO,
     INSERTED.CDFILIAL,
     INSERTED.NRCOLEPRECO,
     INSERTED.CDOPERADOR,
     INSERTED.DTCOLEPREC,
     INSERTED.NRSEMAINIC,
     INSERTED.NRSEMAFINAL,
     INSERTED.DTINIVALCOL,
     INSERTED.DTFINVALCOL,
     INSERTED.NRCOLEORIGCO,
     INSERTED.DTINCLCOLET,
     INSERTED.CDOPERINCL,
     INSERTED.IDDISMONTLIS
   FROM
     INSERTED,
     DELETED
   WHERE
      INSERTED.CDFILIAL    = DELETED.CDFILIAL AND
      INSERTED.NRCOLEPRECO = DELETED.NRCOLEPRECO;

  OPEN C_DADOS;
  FETCH NEXT FROM C_DADOS INTO @V_IDCOMANDO,
                               @V_CDFILIAL,
                               @V_NRCOLEPRECO,
                               @V_CDOPERADOR,
                               @V_DTCOLEPREC,
                               @V_NRSEMAINIC,
                               @V_NRSEMAFINAL,
                               @V_DTINIVALCOL,
                               @V_DTFINVALCOL,
                               @V_NRCOLEORIGCO,
                               @V_DTINCLCOLET,
                               @V_CDOPERINCL,
                               @V_IDDISMONTLIS;

  WHILE (@@FETCH_STATUS = 0) BEGIN

    SET @V_IDGRAVLOGCOT = 'SSS';
    SELECT @V_IDGRAVLOGCOT = ISNULL(MAX(IDGRAVLOGCOT), 'SSS')
    FROM PARASUPRI
    WHERE (CDFILIAL = @V_CDFILIAL);

    SET @V_DSREMOTEADDR = 'VIA BD';
    SET @V_DSREMOTEHOST = 'VIA BD';
    SET @V_DSSERVERRDM  = 'VIA BD';
    SET @V_DSSERVMETHOD = 'VIA BD';
    SET @V_CDOPECOLLOG  = 'VIA BD';
    SELECT @V_DSREMOTEADDR = ISNULL(MAX(DSREMOTEADDR), 'VIA BD'),
           @V_DSREMOTEHOST = ISNULL(MAX(DSREMOTEHOST), 'VIA BD'),
           @V_DSSERVERRDM  = ISNULL(MAX(DSSERVERRDM),  'VIA BD'),
           @V_DSSERVMETHOD = ISNULL(MAX(DSSERVMETHOD), 'VIA BD'),
           @V_CDOPECOLLOG  = ISNULL(MAX(DSREMOTEOPER), 'VIA BD')
    FROM SQLWEBTUNNING
    WHERE NRAUDSID = @@SPID AND
          CONVERT(DATETIME, CONVERT(VARCHAR, DTSTARTDATE, 103))  =
                       (SELECT MAX(DTSTARTDATE)
                                FROM SQLWEBTUNNING S
                                WHERE S.NRAUDSID = @@SPID);

    IF @V_IDCOMANDO = 'U' BEGIN  /* IF UPDATING */

      IF SUBSTRING(@V_IDGRAVLOGCOT, 2, 1) = 'S' BEGIN

         INSERT INTO LOGCOLETAPR
         (CDFILIALLOG,  NRCOLEPRLOG, CDCOMPLOG,
          DTCOLEPRLOG,  NRSEMAINLOG, NRSEMAFILOG,
          DTINIVALLOG,  DTFINVALLOG, DTULTCOLLOG,
          DSRDMUSULOG,  DSENDUSULOG, DSNMUSULOG, DSMETUSULOG, CDOPECOLLOG,
          IDOPERCOTLOG, NRCOLEORILOG, DTINCLITMLOG, CDOPERINCLOG, IDDISMONTLOG)
         VALUES
          (@V_CDFILIAL,    @V_NRCOLEPRECO, @V_CDOPERADOR,
           @V_DTCOLEPREC,  @V_NRSEMAINIC,  @V_NRSEMAFINAL,
           @V_DTINIVALCOL, @V_DTFINVALCOL, GETDATE(),
           @V_DSSERVERRDM, @V_DSREMOTEADDR, @V_DSREMOTEHOST, @V_DSSERVMETHOD, @V_CDOPECOLLOG,
           'A', @V_NRCOLEORIGCO, @V_DTINCLCOLET, @V_CDOPERINCL, @V_IDDISMONTLIS);

      END;

    END;

    IF @V_IDCOMANDO = 'D' BEGIN  /* IF DELETING */

      IF SUBSTRING(@V_IDGRAVLOGCOT, 3, 1) = 'S' BEGIN

        INSERT INTO LOGCOLETAPR
        (CDFILIALLOG,  NRCOLEPRLOG, CDCOMPLOG,
         DTCOLEPRLOG,  NRSEMAINLOG, NRSEMAFILOG,
         DTINIVALLOG,  DTFINVALLOG, DTULTCOLLOG,
         DSRDMUSULOG,  DSENDUSULOG, DSNMUSULOG, DSMETUSULOG, CDOPECOLLOG,
         IDOPERCOTLOG, NRCOLEORILOG, DTINCLITMLOG, CDOPERINCLOG, IDDISMONTLOG)
        VALUES
         (@V_CDFILIAL,    @V_NRCOLEPRECO, @V_CDOPERADOR,
          @V_DTCOLEPREC,  @V_NRSEMAINIC,  @V_NRSEMAFINAL,
          @V_DTINIVALCOL, @V_DTFINVALCOL, GETDATE(),
          @V_DSSERVERRDM, @V_DSREMOTEADDR, @V_DSREMOTEHOST, @V_DSSERVMETHOD, @V_CDOPECOLLOG,
          'E', @V_NRCOLEORIGCO, @V_DTINCLCOLET, @V_CDOPERINCL, @V_IDDISMONTLIS);

      END;

    END;

    FETCH NEXT FROM C_DADOS INTO @V_IDCOMANDO,
                                 @V_CDFILIAL,
                                 @V_NRCOLEPRECO,
                                 @V_CDOPERADOR,
                                 @V_DTCOLEPREC,
                                 @V_NRSEMAINIC,
                                 @V_NRSEMAFINAL,
                                 @V_DTINIVALCOL,
                                 @V_DTFINVALCOL,
                                 @V_NRCOLEORIGCO,
                                 @V_DTINCLCOLET,
                                 @V_CDOPERINCL,
                                 @V_IDDISMONTLIS;
  END;

  CLOSE      C_DADOS;
  DEALLOCATE C_DADOS;

END;
GO
